#include <Servo.h>

// servo stuff
int servoPin = 11;
int pos = 90;    // variable to store the servo position
int dpos = 2;  // increments
int servoDir = 1; //increment 
Servo myservo;  // create servo object to control a servo

//ultrasonic stuff
const int trigPin = 13;
const int echoPin = 12;
long duration;
int distance;


// Motor control pins: L298N H bridge
const int enAPin = 2; // Left motor PWM speed control
const int in1Pin = 3; // Left motor Direction 1
const int in2Pin = 4; // Left motor Direction 2
const int in3Pin = 5; // Right motor Direction 1
const int in4Pin = 6; // Right motor Direction 2
const int enBPin = 7; // Right motor PWM speed control

void check_obstacles()
{
   pos+=servoDir*dpos;
   myservo.write(pos);
   delay(15); 
   if (pos>=180)
   {
    servoDir = -1;
   }
   else if(pos<=0)
   {
    servoDir = +1;
   }
   distance = read_distance();
   Serial.print("Distance: ");
   Serial.println(distance); 
}

long read_distance()
{
  // Clears the trigPin
  digitalWrite(trigPin, LOW);
  delayMicroseconds(2);
  
  // Sets the trigPin on HIGH state for 10 micro seconds
  digitalWrite(trigPin, HIGH);
  delayMicroseconds(10);
  digitalWrite(trigPin, LOW);
  
  // Reads the echoPin, returns the sound wave travel time in microseconds
  duration = pulseIn(echoPin, HIGH);
  
  // Calculating the distance
  distance= duration*0.034/2;
  
  // Prints the distance on the Serial Monitor
//  Serial.print("Distance: ");
//  Serial.println(distance);

  return distance; //returns the distance
}

void motorLeft(int dir, int speed)
{
  if (dir==1)
  {
  digitalWrite(in1Pin,HIGH);
  digitalWrite(in2Pin,LOW);
  }
  else
  {
  digitalWrite(in1Pin,LOW);
  digitalWrite(in2Pin,HIGH);
  }
  analogWrite(enAPin,speed); //needs more than 150 to work
}

void motorRight(int dir, int speed)
{
  if (dir==1)
  {
  digitalWrite(in3Pin,HIGH);
  digitalWrite(in4Pin,LOW);
  }
  else
  {
  digitalWrite(in3Pin,LOW);
  digitalWrite(in4Pin,HIGH);
  }
  analogWrite(enBPin,speed); //needs more than 150 to work
}

void setup() {
  //servo stuff
  myservo.attach(servoPin); 
  myservo.write(pos); //might need calibration

  //ultrasonic stuff 
  pinMode(trigPin, OUTPUT); // Sets the trigPin as an Output
  pinMode(echoPin, INPUT); // Sets the echoPin as an Input

  Serial.begin(9600); // Starts the serial communication
  
  //motor stuff
  pinMode(enAPin, OUTPUT);
  pinMode(in1Pin, OUTPUT);
  pinMode(in2Pin, OUTPUT);
  pinMode(in3Pin, OUTPUT);
  pinMode(in4Pin, OUTPUT);
  pinMode(enBPin, OUTPUT);

}
  
void loop() {
  check_obstacles();

  //go forward
  motorLeft(-1,150);
  motorRight(-1,150);
  delay(500);

   //stop
  motorLeft(1,0);
  motorRight(1,0);
   delay(500);

  //go backward
  motorLeft(1,150);
  motorRight(1,150);
   delay(500);

    //stop
  motorLeft(1,0);
  motorRight(1,0);
   delay(500);

  //go left
  motorLeft(1,150);
  motorRight(-1,150);
   delay(500);

    //stop
  motorLeft(1,0);
  motorRight(1,0);
   delay(500);

  //go right
  motorLeft(-1,150);
  motorRight(1,150);
   delay(500);

 //stop
  motorLeft(1,0);
  motorRight(1,0);
   delay(500);

  
}
